set Konf(Ordner) [file join $env(HOME) $ProgrammOrdner $ProgrammName]
if {[file exist $Konf(Ordner)] == 0} {
	file mkdir $Konf(Ordner)
}

::msgcat::mclocale en
::msgcat::mcload [file join [file dirname $Konf(Skriptname)]]

set Konf(Datei) [file join $Konf(Ordner) $ProgrammName.conf] ; # Dateiname der Konfigurationsdatei
set Konf(Sprache) English ; # Sprache (Default-Wert)

# **** Prozeduren, die keine anderen Prozeduren aufrufen ***

proc SpracheEinstellen {} {
	global Konf
	global StufenMax

	switch $Konf(Sprache) {
		Deutsch {set SpracheKurzform de}
		English {set SpracheKurzform en}
		default {set Konf(Sprache) English; set SpracheKurzform en}
	}
	::msgcat::mclocale $SpracheKurzform
	::msgcat::mcload [file join [file dirname $Konf(Skriptname)]]
}

proc KonfigurationSpeichern {StufenMax} {
  global Konf
  #global StufenMax

  set f [open $Konf(Datei) w]
  puts $f "<01>$Konf(Sprache)"
  puts $f "<02>$Konf(Einstellungen,Stufe)"
  for {set tmpStufe 1} {$tmpStufe <= $StufenMax} {incr tmpStufe} {
		puts $f "<03,$tmpStufe>$Konf($tmpStufe,Anzahl)"
    	for {set i 0} {$i <= 3} {incr i} {
			puts $f "<04,$tmpStufe,$i>$Konf($tmpStufe,$i,JaNein)"
			puts $f "<05,$tmpStufe,$i>$Konf($tmpStufe,$i,Von)"
			puts $f "<06,$tmpStufe,$i>$Konf($tmpStufe,$i,Bis)"
			if {$i >= 2} {
				puts $f "<07,$tmpStufe,$i>$Konf($tmpStufe,$i,Variante)"
			}
			puts $f "<08,$tmpStufe,$i>$Konf($tmpStufe,$i,FrageNachZahl1)"
			puts $f "<09,$tmpStufe,$i>$Konf($tmpStufe,$i,FrageNachZahl2)"
			puts $f "<10,$tmpStufe,$i>$Konf($tmpStufe,$i,FrageNachZahl3)"
			puts $f "<11,$tmpStufe,$i>$Konf($tmpStufe,$i,Zeit)"
		}
  }
  close $f
}

proc KonfigurationEinlesen {StufeEinlesen StufenMax} {
	# StufeEinlesen: Boolean. 1=Stufe soll eingelesen werden. Wenn der Anwender im Einstellungsdialog die Stufe ändert, darf die Stufe nicht eingelesen werden
	
  global Konf
  #global Glob
	
  if {[glob -nocomplain -types f $Konf(Datei)] eq ""} {return}
  set f [open $Konf(Datei) r]
  while {[gets $f Zeile] >= 0} {
	if {[string range $Zeile 0 3] eq "<01>"} {set Konf(Sprache) [string range $Zeile 4 end]}
	if {$StufeEinlesen == 1} {
  	  if {[string range $Zeile 0 3] eq "<02>"} {set Konf(Einstellungen,Stufe) [string range $Zeile 4 end]}
	}
  	for {set tmpStufe 1} {$tmpStufe <= $StufenMax} {incr tmpStufe} {
		if {[string range $Zeile 0 5] eq "<03,$tmpStufe>"} {set Konf($tmpStufe,Anzahl) [string range $Zeile 6 end]}
    	for {set i 0} {$i <= 3} {incr i} {
			if {[string range $Zeile 0 7] eq "<04,$tmpStufe,$i>"} {set Konf($tmpStufe,$i,JaNein) [string range $Zeile 8 end]}
			if {[string range $Zeile 0 7] eq "<05,$tmpStufe,$i>"} {set Konf($tmpStufe,$i,Von) [string range $Zeile 8 end]}
			if {[string range $Zeile 0 7] eq "<06,$tmpStufe,$i>"} {set Konf($tmpStufe,$i,Bis) [string range $Zeile 8 end]}
			if {$i >= 2} {
				if {[string range $Zeile 0 7] eq "<07,$tmpStufe,$i>"} {set Konf($tmpStufe,$i,Variante) [string range $Zeile 8 end]}
			}
			if {[string range $Zeile 0 7] eq "<08,$tmpStufe,$i>"} {set Konf($tmpStufe,$i,FrageNachZahl1) [string range $Zeile 8 end]}
			if {[string range $Zeile 0 7] eq "<09,$tmpStufe,$i>"} {set Konf($tmpStufe,$i,FrageNachZahl2) [string range $Zeile 8 end]}
			if {[string range $Zeile 0 7] eq "<10,$tmpStufe,$i>"} {set Konf($tmpStufe,$i,FrageNachZahl3) [string range $Zeile 8 end]}
			if {[string range $Zeile 0 7] eq "<11,$tmpStufe,$i>"} {set Konf($tmpStufe,$i,Zeit) [string range $Zeile 8 end]}
		}
	} 
  }
  close $f
}

proc InfoAnzeigen {ProgrammName ProgrammVersion} {
	set Titel [::msgcat::mc "Info"]
	set Text "${ProgrammName}\nVersion ${ProgrammVersion}\n\nCopyright (C) 2014 Oliver Scholl\nwww.tcltk.info\n
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the license, or any later version.\n
This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of merchantability or fitness for a particular purpose. See the GNU General Public License for mor details."
	tk_messageBox -title $Titel -message $Text -type ok
}

# **** Prozeduren, die andere Prozeduren aufrufen ***

proc SpracheAendern {} {
	SpracheEinstellen
	set Titel [::msgcat::mc "Hinweis"]
	set Text [::msgcat::mc "Die Änderung wird erst nach einem Neustart des Programms wirksam."]
	tk_messageBox -title $Titel -message $Text -type ok
}
